load tclping.dll

proc Traceroute {host {ttl 0}} {
  global hostlist

  incr ttl

  if {$ttl>20} {
    return ""
  }

  if {[catch {ping $host -ttl $ttl} msg]} {
    return
  } else {
    set curhost ""
    set expired 0
    set pc 0
    foreach a $msg {
      if {[llength $a]==1} {
        incr pc
        continue
      }
      set ct [lindex [lindex [lindex $msg 0] 1] 0]
      if {[string length $curhost] && [string compare $curhost $ct]} {
        puts "hey! mismatch $curhost != $ct"
      }
      set curhost $ct
      if {[string match *expired* $a]} {
        set expired 1
      }
    }
   
    if {$pc==3} {
       set fconn [Traceroute $host $ttl]
       return ""
    }     

    if {$expired} {
       set fconn [Traceroute $host $ttl]
       puts $curhost
       puts $fconn
       if {[string length $fconn]} {  
         if {[info exists hostlist($curhost)]} {      
           if {[lsearch -exact $hostlist($curhost) $fconn]==-1} {
             lappend hostlist($curhost) $fconn
           }
         } else {
           set hostlist($curhost) $fconn
         }
       }
    }
     
    return $curhost
  }


}

proc Dump {} {
  global hostlist
 
  foreach a [array names hostlist] {
    puts "$a: $hostlist($a)"
  } 
}

proc DumpG {} {
  global hostlist

  set f [open c:/temp/graph.g w]
  puts $f "digraph g \{"
  foreach a [array names hostlist] {
    foreach b $hostlist($a) {
      puts $f "\"$a\" -> \"$b\""
    }
  } 

  puts $f "\}"
  close $f
}    



   
